// JavaScript Document

//validate a form
function validate_form(myForm) {

	//loading image when form submitted
	$(myForm).submit(function() {
		
		//get form ID
		var form_id = "#"+this.id;
		
		//assume we are OK
		var isMissing = false;
		
		$(form_id+' .errmsg').text('');
		
		//loop through required fields
		$(form_id+' .required').each(function(){
			
			//remove the missing class
			$(this).removeClass("missing");
			
			//if blank, add the missing class back
			if ($(this).val() == "") {
				$(this).addClass("missing");
				$(form_id+' #err_' + this.id).text(' *Required');
				isMissing = true
			};
			
		});
		
		//make sure the card number is 14 digits if that field exists. IF not required or value is N/A, skip
		if ($(form_id+' #card_number').length != 0 && $(form_id+' #card_number').hasClass('required') && $(form_id+' #card_number').val() != 'N/A') {
			if ($(form_id+' #card_number').val().length != 14) {
				$(form_id+' #card_number').addClass("missing");
				$(form_id+' #err_card_number').text(' *Must be 14 digits');
				isMissing = true;
			}
		}
		
		//make sure the email address is valid!
		if ($(form_id+' #email_address').length != 0) {
			if (!validateEmail($(form_id+' #email_address').val())) {
				$(form_id+' #email_address').addClass("missing");
				$(form_id+' #err_email_address').text(' *Not a valid email');
				isMissing = true;
			}
		}
		
		//if there is a email confirm field, validate it matches the email field
		if ($(form_id+' #email_address_confirm').length != 0) {
			if ($(form_id+' #email_address_confirm').val() != $(form_id+' #email_address').val()) {
				$(form_id+' #email_address_confirm,'+form_id+' #email_address').addClass("missing");
				$(form_id+' #err_email_address,'+form_id+' #email_address_confirm').text(' *Emails must match');
				isMissing = true;
			}
		}
		
		//if there is a captcha field, validate it matches the captcha confirm field
		if ($(form_id+' #captcha').length != 0) {
			if ($(form_id+' #captcha_confirm').val() != $(form_id+' #captcha').val()) {
				$(form_id+' #captcha_confirm').addClass("missing");
				$(form_id+' #captcha_confirm').text(' *Verification code does not match');
				isMissing = true;
			}
		}
		
		//we want password that are at least 6 characters for security purposes
		if ($(form_id+' #password').length != 0 && $(form_id+' #password').hasClass('required')) {
			if ($(form_id+' #password').val().length < 6) {
				$(form_id+' #password_confirm,'+form_id+' #password').addClass("missing");
				$(form_id+' #err_password_confirm,'+form_id+' #err_password').text(" *Must be at least 6 characters");
				isMissing = true;
			}
		}
			
		//if there is a password confirm field, validate it matches the password field
		if ($(form_id+' #password_confirm').length != 0) {
			
			//check if password matches confirm password field
			if ($(form_id+' #password_confirm').val() != $('#password').val()) {
				$(form_id+' #password_confirm,'+form_id+' #password').addClass("missing");
				$(form_id+' #err_password_confirm,'+form_id+' #err_password').text(" *Passwords must match");
				isMissing = true;
			}
		}
						
		if (!isMissing) {
			
			if ($('#loading').length != 0) {
				$('#loading').show(); // show animation
			}
			
			if ($('#registering').length != 0) {
				$('#registering').show(); // show different animation
			}
			return true;
			document.myForm.submit();
		} else {
			return false;
		}
	});
}

//validate an email against a regular expression
function validateEmail($email) {

	var emailReg = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/;
	
	if( !emailReg.test( $email ) ) {
		return false;
	} else {
		return true;
	}
}

//get a querystring variable
function getQueryString(name) {

	name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
	var regexS = "[\\?&]" + name + "=([^&#]*)";
	var regex = new RegExp(regexS);
	var results = regex.exec(window.location.search);
	
	if(results == null) {
		return "";
	} else {
		return decodeURIComponent(results[1].replace(/\+/g, " "));
	}
}

//jump to a url from <select> element
function select_link(type) {
	
	var url = $("#select-"+type).val();
	window.location.href = url;
}

//used by datepicker function to parse JSON array availableDates and enable valid showdates
function available(date) {
	
	//format date		
	mdy =   (date.getMonth()+1) + "/" + date.getDate() + "/" + date.getFullYear();
	console.log(mdy+' : '+($.inArray(mdy, availableDates)));
    
    //valid or not?
	if ($.inArray(mdy, availableDates) != -1) {
		return [true, "","Available"];
	} else {
		return [false,"","unAvailable"];
	}
}

$.widget( "custom.catcomplete", $.ui.autocomplete, {
	_renderMenu: function( ul, items ) {
		var self = this,
			currentCategory = "";
		$.each( items, function( index, item ) {
			if ( item.category != currentCategory ) {
				ul.append( "<li class='ui-autocomplete-category'>" + item.category + "</li>" );
				ul.append("<li class='ui-menu-item'><a href='" + item.value + "'>" + item.label + "</a></li>");
				currentCategory = item.category;
			} else {
				if (item.value == "NULL") {
					ul.append("<li class='ui-menu-item'>" + item.label + "</li>");
				} else {
					ul.append("<li class='ui-menu-item'><a href='" + item.value + "'>" + item.label + "</a></li>");
				}
			}
			//self._renderItem(ul, item);
		});
	}
});

/**
 * Retrieve cookie
 * @param {String} cname - cookie name to search for
 * @return {String} - value of found cookie
 */
function getCookie (cname) {
  var name = cname + "=";
  var decodedCookie = decodeURIComponent(document.cookie);
  var ca = decodedCookie.split(';');
  for(var i = 0; i <ca.length; i++) {
      var c = ca[i];
      while (c.charAt(0) == ' ') {
          c = c.substring(1);
      }
      if (c.indexOf(name) == 0) {
          return c.substring(name.length, c.length);
      }
  }
  return "";
}

/**
 * Set cookie
 * @param {String} name - cookie name 
 * @param {String} value - value of cookie
 * @param {String} daysToExpire - expire in this many days
 */
function setCookie (name, value, daysToExpire) {
  var d = new Date();
  d.setTime(d.getTime() + (daysToExpire*24*60*60*1000));
  var expires = "expires="+ d.toUTCString();
  document.cookie = name + "=" + value + ";" + expires + ";path=/";
};


//document ready
$(function () {
	
  if (!getCookie('loyaltypopup')) {
    $.get('/includes/data/popup.html', function(data) {
			if (!data) {
				setCookie('loyaltypopup', true, 0.041667);
				return;
			}
      setCookie('loyaltypopup', true, 30);
      $.alert({
        title: 'Loyalty',
        content: data,
        theme: 'dark',
        backgroundDismiss: true,
        closeIcon: true,
        columnClass: 'loyalty',
        boxWidth: ($(window).width() < 768) ? '80%' : '50%',
        theme: 'loyalty'
      });
    });
  }

	if ($(window).width() < 600){
		$('#mobile-menu').on('click', function(){
			$('#nav').toggle('slow');
			
			return false;
		});
	}
	
	//hold hover on parent nav element when in subnav
	$(".subNavContainer").mouseenter(function () {
		$(this).find(".nav-dropdown").addClass("active");
	}).mouseleave(function () {
		$(this).find(".nav-dropdown").removeClass("active");
	});
	
	//autocomplete search
	$(".ajax-search").catcomplete({
      source: function(request, response) {
        $.ajax({
            url: "/includes/ajax-search",
            dataType: "json",
            data: {
                term: request.term,
                site: $("#siteid").val(),
            },
            success: function(data) {
                response(data);
            }
        })
      },
      minLength: 2,
      search: function () {
	    $(".ajax-loader").show();
      },
	  response: function () {
		$(".ajax-loader").hide();
	  },
	  select: function(event, ui) {
	  	
	  }
    });
    
    //hide the coming soon carousel
	$('#car_comingsoon').hide();
	
	var itemsToShow = 4;
	if($(window).width() < 600){
		itemsToShow = 3;
	}
	
	//toggle the carousel when NP or CS buttons are clicked
	$('#but_nowplaying').click(function() {
		$('#car_comingsoon').hide();
		$('#car_nowplaying').fadeIn();
		$(this).addClass("active");
		$('#but_comingsoon').removeClass("active");
		
		//start the now playing carousel
		$("#nowplaying").carouFredSel({
			responsive: true,
			circular: true,
			infinite: true,
			items: itemsToShow,
			scroll: { 
				items:itemsToShow,
				duration: 1000,
				easing: "quadratic",
			},
			auto: true,
			prev: {
				button: "#nowplaying_prev",
				key: "left"
			},
			next: {
				button: "#nowplaying_next",
				key: "right"
			},
			swipe : { 
				onTouch : true
			} 
		});
	});
	
	$('#but_comingsoon').click(function() {
		$('#car_nowplaying').hide();
		$('#car_comingsoon').fadeIn();
		$(this).addClass("active");
		$('#but_nowplaying').removeClass("active");
		
		//start the coming soon carousel
		$("#comingsoon").carouFredSel({
			responsive:true,
			circular: true,
			infinite: true,
			items: itemsToShow,
			scroll: { 
				items:itemsToShow,
				duration: 1000,
				easing: "quadratic",
			},
			auto: true,				
			prev: {
				button: "#comingsoon_prev",
				key: "left"
			},
			next: {
				button: "#comingsoon_next",
				key: "right"
			},
			swipe : { 
				onTouch : true
			}  
		});
	});
	
	//trigger the now playing button click
	$('#but_nowplaying').trigger("click");
	
	var mainAdvance = false;
	console.log($('.camera_wrap_left div[data-thumb]').length);
	//start the camera slider
	$('.camera_wrap_1').camera({
		height: '250px',
		pagination: false,
		thumbnails: false,
		playPause: false,
		time: 5000,
		transPeriod: 700,
		fx: 'simplefade',
		bypassCache: false,
		loader: 'none',
		autoAdvance: $('.camera_wrap_1 div[data-thumb]').length > 1 ? true : false
	});

	//start the camera slider
	$('.camera_wrap_left').camera({
		height: '250px',
		pagination: false,
		thumbnails: false,
		playPause: false,
		time: 5000,
		transPeriod: 700,
		fx: 'simplefade',
		bypassCache: false,
		loader: 'none',
		autoAdvance: $('.camera_wrap_left div[data-thumb]').length > 1 ? true : false
	});
	
	//start the camera slider
	$('.camera_wrap_right').camera({
		height: '250px',
		pagination: false,
		thumbnails: false,
		playPause: false,
		time: 5000,
		transPeriod: 700,
		fx: 'simplefade',
		bypassCache: false,
		loader: 'none',
		autoAdvance: $('.camera_wrap_right div[data-thumb]').length > 1 ? true : false
	});
	
	//start the camera slider
	$('.camera_wrap_2').camera({
		width: '261px',
		pagination: false,
		loaderOpacity: 0,
		loader: 'none',
		thumbnails: false,
		playPause: false,
		time: 3000,
		transPeriod: 700,
		fx: 'simplefade',
		bypassCache: false,
		loader: 'none',
	});

	//start trailer when button is pressed
	$(".play-trailer").fancybox({
		autoscale : false,
		width : 800,
		height : 450,
		transitionIn : 'none',
		transitionOut : 'none',
		padding : 0,
		scrolling  : 'no',
		title : $(this).title,
		href : this.href,
		beforeShow: function(){
		  $(".fancybox-skin").css("backgroundColor","#000000");
		}
	});
	
	//lets open up the gallery for Facebook 
	$(".event").fancybox({
		
		autoSize : false,
		width : 750,
		height : 500,
		type : 'iframe',
		closeBtn : false,
		closeClick : true,
		transitionIn : 'none',
		transitionOut : 'none',
		padding : 0,
		scrolling  : 'yes',
		title : $(this).title,
		href : this.href,
		beforeShow: function(){
		  $(".fancybox-skin").css("backgroundColor","transparent");
		}
	});
	
	
	
	//lets open up the gallery for Facebook 
	$(".fbGallery").fancybox({
		
		autoscale : false,
		width : 800,
		closeBtn : false,
		closeClick : true,
		height : 500,
		transitionIn : 'none',
		transitionOut : 'none',
		padding : 0,
		scrolling  : 'no',
		title : $(this).title,
		href : this.href,
		beforeShow: function(){
		  $(".fancybox-skin").css("backgroundColor","transparent");
		}
	});
})